// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"net/http"
	"strings"

	errors "github.com/go-openapi/errors"
	loads "github.com/go-openapi/loads"
	runtime "github.com/go-openapi/runtime"
	middleware "github.com/go-openapi/runtime/middleware"
	security "github.com/go-openapi/runtime/security"
	spec "github.com/go-openapi/spec"
	strfmt "github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"ticket-boss/restapi/operations/events"
	"ticket-boss/restapi/operations/statistics"
	"ticket-boss/restapi/operations/users"
)

// NewTicketbossAPI creates a new Ticketboss instance
func NewTicketbossAPI(spec *loads.Document) *TicketbossAPI {
	return &TicketbossAPI{
		handlers:            make(map[string]map[string]http.Handler),
		formats:             strfmt.Default,
		defaultConsumes:     "application/json",
		defaultProduces:     "application/json",
		customConsumers:     make(map[string]runtime.Consumer),
		customProducers:     make(map[string]runtime.Producer),
		ServerShutdown:      func() {},
		spec:                spec,
		ServeError:          errors.ServeError,
		BasicAuthenticator:  security.BasicAuth,
		APIKeyAuthenticator: security.APIKeyAuth,
		BearerAuthenticator: security.BearerAuth,
		JSONConsumer:        runtime.JSONConsumer(),
		XMLConsumer:         runtime.XMLConsumer(),
		JSONProducer:        runtime.JSONProducer(),
		XMLProducer:         runtime.XMLProducer(),
		EventsEventRequestHandler: events.EventRequestHandlerFunc(func(params events.EventRequestParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation EventsEventRequest has not yet been implemented")
		}),
		EventsEventsHandler: events.EventsHandlerFunc(func(params events.EventsParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation EventsEvents has not yet been implemented")
		}),
		EventsSingleEventRequestHandler: events.SingleEventRequestHandlerFunc(func(params events.SingleEventRequestParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation EventsSingleEventRequest has not yet been implemented")
		}),
		StatisticsStatisticsHandler: statistics.StatisticsHandlerFunc(func(params statistics.StatisticsParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation StatisticsStatistics has not yet been implemented")
		}),
		EventsTicketTypeRequestHandler: events.TicketTypeRequestHandlerFunc(func(params events.TicketTypeRequestParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation EventsTicketTypeRequest has not yet been implemented")
		}),
		UsersUserRequestHandler: users.UserRequestHandlerFunc(func(params users.UserRequestParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation UsersUserRequest has not yet been implemented")
		}),
		UsersUsersHandler: users.UsersHandlerFunc(func(params users.UsersParams, principal *ticketboss) middleware.Responder {
			return middleware.NotImplemented("operation UsersUsers has not yet been implemented")
		}),

		// Applies when the "KEY" header is set
		APIKeyAuth: func(token string) (*ticketboss, error) {
			return nil, errors.NotImplemented("api key auth (api_key) KEY from header param [KEY] has not yet been implemented")
		},

		// default authorizer is authorized meaning no requests are blocked
		APIAuthorizer: security.Authorized(),
	}
}

/*TicketbossAPI This is the core application that powers ticket boss ticketing sytem. */
type TicketbossAPI struct {
	spec            *loads.Document
	context         *middleware.Context
	handlers        map[string]map[string]http.Handler
	formats         strfmt.Registry
	customConsumers map[string]runtime.Consumer
	customProducers map[string]runtime.Producer
	defaultConsumes string
	defaultProduces string
	Middleware      func(middleware.Builder) http.Handler

	// BasicAuthenticator generates a runtime.Authenticator from the supplied basic auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BasicAuthenticator func(security.UserPassAuthentication) runtime.Authenticator
	// APIKeyAuthenticator generates a runtime.Authenticator from the supplied token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	APIKeyAuthenticator func(string, string, security.TokenAuthentication) runtime.Authenticator
	// BearerAuthenticator generates a runtime.Authenticator from the supplied bearer token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BearerAuthenticator func(string, security.ScopedTokenAuthentication) runtime.Authenticator

	// JSONConsumer registers a consumer for a "application/json" mime type
	JSONConsumer runtime.Consumer
	// XMLConsumer registers a consumer for a "application/xml" mime type
	XMLConsumer runtime.Consumer

	// JSONProducer registers a producer for a "application/json" mime type
	JSONProducer runtime.Producer
	// XMLProducer registers a producer for a "application/xml" mime type
	XMLProducer runtime.Producer

	// APIKeyAuth registers a function that takes a token and returns a principal
	// it performs authentication based on an api key KEY provided in the header
	APIKeyAuth func(string) (*ticketboss, error)

	// APIAuthorizer provides access control (ACL/RBAC/ABAC) by providing access to the request and authenticated principal
	APIAuthorizer runtime.Authorizer

	// EventsEventRequestHandler sets the operation handler for the event request operation
	EventsEventRequestHandler events.EventRequestHandler
	// EventsEventsHandler sets the operation handler for the events operation
	EventsEventsHandler events.EventsHandler
	// EventsSingleEventRequestHandler sets the operation handler for the single event request operation
	EventsSingleEventRequestHandler events.SingleEventRequestHandler
	// StatisticsStatisticsHandler sets the operation handler for the statistics operation
	StatisticsStatisticsHandler statistics.StatisticsHandler
	// EventsTicketTypeRequestHandler sets the operation handler for the ticket type request operation
	EventsTicketTypeRequestHandler events.TicketTypeRequestHandler
	// UsersUserRequestHandler sets the operation handler for the user request operation
	UsersUserRequestHandler users.UserRequestHandler
	// UsersUsersHandler sets the operation handler for the users operation
	UsersUsersHandler users.UsersHandler

	// ServeError is called when an error is received, there is a default handler
	// but you can set your own with this
	ServeError func(http.ResponseWriter, *http.Request, error)

	// ServerShutdown is called when the HTTP(S) server is shut down and done
	// handling all active connections and does not accept connections any more
	ServerShutdown func()

	// Custom command line argument groups with their descriptions
	CommandLineOptionsGroups []swag.CommandLineOptionsGroup

	// User defined logger function.
	Logger func(string, ...interface{})
}

// SetDefaultProduces sets the default produces media type
func (o *TicketbossAPI) SetDefaultProduces(mediaType string) {
	o.defaultProduces = mediaType
}

// SetDefaultConsumes returns the default consumes media type
func (o *TicketbossAPI) SetDefaultConsumes(mediaType string) {
	o.defaultConsumes = mediaType
}

// SetSpec sets a spec that will be served for the clients.
func (o *TicketbossAPI) SetSpec(spec *loads.Document) {
	o.spec = spec
}

// DefaultProduces returns the default produces media type
func (o *TicketbossAPI) DefaultProduces() string {
	return o.defaultProduces
}

// DefaultConsumes returns the default consumes media type
func (o *TicketbossAPI) DefaultConsumes() string {
	return o.defaultConsumes
}

// Formats returns the registered string formats
func (o *TicketbossAPI) Formats() strfmt.Registry {
	return o.formats
}

// RegisterFormat registers a custom format validator
func (o *TicketbossAPI) RegisterFormat(name string, format strfmt.Format, validator strfmt.Validator) {
	o.formats.Add(name, format, validator)
}

// Validate validates the registrations in the TicketbossAPI
func (o *TicketbossAPI) Validate() error {
	var unregistered []string

	if o.JSONConsumer == nil {
		unregistered = append(unregistered, "JSONConsumer")
	}

	if o.XMLConsumer == nil {
		unregistered = append(unregistered, "XMLConsumer")
	}

	if o.JSONProducer == nil {
		unregistered = append(unregistered, "JSONProducer")
	}

	if o.XMLProducer == nil {
		unregistered = append(unregistered, "XMLProducer")
	}

	if o.APIKeyAuth == nil {
		unregistered = append(unregistered, "KEYAuth")
	}

	if o.EventsEventRequestHandler == nil {
		unregistered = append(unregistered, "events.EventRequestHandler")
	}

	if o.EventsEventsHandler == nil {
		unregistered = append(unregistered, "events.EventsHandler")
	}

	if o.EventsSingleEventRequestHandler == nil {
		unregistered = append(unregistered, "events.SingleEventRequestHandler")
	}

	if o.StatisticsStatisticsHandler == nil {
		unregistered = append(unregistered, "statistics.StatisticsHandler")
	}

	if o.EventsTicketTypeRequestHandler == nil {
		unregistered = append(unregistered, "events.TicketTypeRequestHandler")
	}

	if o.UsersUserRequestHandler == nil {
		unregistered = append(unregistered, "users.UserRequestHandler")
	}

	if o.UsersUsersHandler == nil {
		unregistered = append(unregistered, "users.UsersHandler")
	}

	if len(unregistered) > 0 {
		return fmt.Errorf("missing registration: %s", strings.Join(unregistered, ", "))
	}

	return nil
}

// ServeErrorFor gets a error handler for a given operation id
func (o *TicketbossAPI) ServeErrorFor(operationID string) func(http.ResponseWriter, *http.Request, error) {
	return o.ServeError
}

// AuthenticatorsFor gets the authenticators for the specified security schemes
func (o *TicketbossAPI) AuthenticatorsFor(schemes map[string]spec.SecurityScheme) map[string]runtime.Authenticator {

	result := make(map[string]runtime.Authenticator)
	for name, scheme := range schemes {
		switch name {

		case "api_key":

			result[name] = o.APIKeyAuthenticator(scheme.Name, scheme.In, func(token string) (interface{}, error) {
				return o.APIKeyAuth(token)
			})

		}
	}
	return result

}

// Authorizer returns the registered authorizer
func (o *TicketbossAPI) Authorizer() runtime.Authorizer {

	return o.APIAuthorizer

}

// ConsumersFor gets the consumers for the specified media types
func (o *TicketbossAPI) ConsumersFor(mediaTypes []string) map[string]runtime.Consumer {

	result := make(map[string]runtime.Consumer)
	for _, mt := range mediaTypes {
		switch mt {

		case "application/json":
			result["application/json"] = o.JSONConsumer

		case "application/xml":
			result["application/xml"] = o.XMLConsumer

		}

		if c, ok := o.customConsumers[mt]; ok {
			result[mt] = c
		}
	}
	return result

}

// ProducersFor gets the producers for the specified media types
func (o *TicketbossAPI) ProducersFor(mediaTypes []string) map[string]runtime.Producer {

	result := make(map[string]runtime.Producer)
	for _, mt := range mediaTypes {
		switch mt {

		case "application/json":
			result["application/json"] = o.JSONProducer

		case "application/xml":
			result["application/xml"] = o.XMLProducer

		}

		if p, ok := o.customProducers[mt]; ok {
			result[mt] = p
		}
	}
	return result

}

// HandlerFor gets a http.Handler for the provided operation method and path
func (o *TicketbossAPI) HandlerFor(method, path string) (http.Handler, bool) {
	if o.handlers == nil {
		return nil, false
	}
	um := strings.ToUpper(method)
	if _, ok := o.handlers[um]; !ok {
		return nil, false
	}
	if path == "/" {
		path = ""
	}
	h, ok := o.handlers[um][path]
	return h, ok
}

// Context returns the middleware context for the ticketboss API
func (o *TicketbossAPI) Context() *middleware.Context {
	if o.context == nil {
		o.context = middleware.NewRoutableContext(o.spec, o, nil)
	}

	return o.context
}

func (o *TicketbossAPI) initHandlerCache() {
	o.Context() // don't care about the result, just that the initialization happened

	if o.handlers == nil {
		o.handlers = make(map[string]map[string]http.Handler)
	}

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/events"] = events.NewEventRequest(o.context, o.EventsEventRequestHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/events"] = events.NewEvents(o.context, o.EventsEventsHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/events/{id}"] = events.NewSingleEventRequest(o.context, o.EventsSingleEventRequestHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/statistics"] = statistics.NewStatistics(o.context, o.StatisticsStatisticsHandler)

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/events/{id}/tickettypes"] = events.NewTicketTypeRequest(o.context, o.EventsTicketTypeRequestHandler)

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/users"] = users.NewUserRequest(o.context, o.UsersUserRequestHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/users"] = users.NewUsers(o.context, o.UsersUsersHandler)

}

// Serve creates a http handler to serve the API over HTTP
// can be used directly in http.ListenAndServe(":8000", api.Serve(nil))
func (o *TicketbossAPI) Serve(builder middleware.Builder) http.Handler {
	o.Init()

	if o.Middleware != nil {
		return o.Middleware(builder)
	}
	return o.context.APIHandler(builder)
}

// Init allows you to just initialize the handler cache, you can then recompose the middleware as you see fit
func (o *TicketbossAPI) Init() {
	if len(o.handlers) == 0 {
		o.initHandlerCache()
	}
}

// RegisterConsumer allows you to add (or override) a consumer for a media type.
func (o *TicketbossAPI) RegisterConsumer(mediaType string, consumer runtime.Consumer) {
	o.customConsumers[mediaType] = consumer
}

// RegisterProducer allows you to add (or override) a producer for a media type.
func (o *TicketbossAPI) RegisterProducer(mediaType string, producer runtime.Producer) {
	o.customProducers[mediaType] = producer
}
